#[derive(Clone, Debug, Hash)]
pub enum Error {
    SyntaxError(SyntaxError),
}

#[derive(Clone, Debug, Hash)]
pub struct SyntaxError {
    pub row: usize,
    pub column: usize,
    pub message: String,
}

pub type Result<T> = ::core::result::Result<T, Error>;

impl std::fmt::Display for Error {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        match self {
            Error::SyntaxError(e) => write!(f, "Error at: {}:{}. {}", e.row, e.column, e.message),
        }
    }
}

impl std::error::Error for Error {}
